#ifndef _DEFINES_H_
#define _DEFINES_H_

#define OP_NOP           0
#define OP_LOAD          1
#define OP_MOVE          2
#define OP_NEW_VEC       3
#define OP_EXTEND        4
#define OP_JUMP          5
#define OP_JUMP_IF_FALSE 6
#define OP_TAIL_CALL     7
#define OP_CALL          8
#define OP_RETURN        9

#define REG_LIB 255 // -1
#define REG_GLO 254 // -2
#define REG_RES 253 // -3
#define REG_TMP 252 // -4
#define REG_VEC 251 // -5

#define TYPE_NIL   0
#define TYPE_BOOL  1
#define TYPE_INT   2
#define TYPE_CHAR  3
#define TYPE_STR   4
#define TYPE_SYM   5
#define TYPE_CLO_F 6
#define TYPE_CLO_D 7
#define TYPE_VOID  8

// tags in the order of constructors in values.cpp.ml
#define VAL_VOID  1 // (0 << 1 | 1)
#define VAL_NIL   3 // (1 << 1 | 1)
#define VAL_TRUE  5 // (2 << 1 | 1)
#define VAL_FALSE 7 // (3 << 1 | 1)


#define _QUOTEME(x) #x
#define QUOTEME(x) _QUOTEME(x)

#ifdef RELEASE
#define ASSERT(exp) ()
#else
#define ASSERT(exp) \
    if (exp) \
    then () \
    else raise (ASSERTION_ERROR ("line: " ^ QUOTEME(__LINE__) ^ \
                                 " in file: " ^ __FILE__ ^ \
                                 " expression failed: " ^ #exp))
#endif

#endif // _DEFINES_H_
